import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleClientOpenidUserinfoConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/d/google_client_openid_userinfo#id DataGoogleClientOpenidUserinfo#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/google-beta/d/google_client_openid_userinfo google_client_openid_userinfo}
*/
export declare class DataGoogleClientOpenidUserinfo extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_client_openid_userinfo";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/google-beta/d/google_client_openid_userinfo google_client_openid_userinfo} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleClientOpenidUserinfoConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGoogleClientOpenidUserinfoConfig);
    get email(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
