import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleContainerAwsVersionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/d/google_container_aws_versions#id DataGoogleContainerAwsVersions#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/d/google_container_aws_versions#location DataGoogleContainerAwsVersions#location}
    */
    readonly location?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/d/google_container_aws_versions#project DataGoogleContainerAwsVersions#project}
    */
    readonly project?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/google-beta/d/google_container_aws_versions google_container_aws_versions}
*/
export declare class DataGoogleContainerAwsVersions extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_container_aws_versions";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/google-beta/d/google_container_aws_versions google_container_aws_versions} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleContainerAwsVersionsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGoogleContainerAwsVersionsConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    get supportedRegions(): string[];
    get validVersions(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
