import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GooglePubsubSubscriptionIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#id GooglePubsubSubscriptionIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#member GooglePubsubSubscriptionIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#project GooglePubsubSubscriptionIamMember#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#role GooglePubsubSubscriptionIamMember#role}
    */
    readonly role: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#subscription GooglePubsubSubscriptionIamMember#subscription}
    */
    readonly subscription: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#condition GooglePubsubSubscriptionIamMember#condition}
    */
    readonly condition?: GooglePubsubSubscriptionIamMemberCondition;
}
export interface GooglePubsubSubscriptionIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#description GooglePubsubSubscriptionIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#expression GooglePubsubSubscriptionIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member#title GooglePubsubSubscriptionIamMember#title}
    */
    readonly title: string;
}
export declare function googlePubsubSubscriptionIamMemberConditionToTerraform(struct?: GooglePubsubSubscriptionIamMemberConditionOutputReference | GooglePubsubSubscriptionIamMemberCondition): any;
export declare class GooglePubsubSubscriptionIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GooglePubsubSubscriptionIamMemberCondition | undefined;
    set internalValue(value: GooglePubsubSubscriptionIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member google_pubsub_subscription_iam_member}
*/
export declare class GooglePubsubSubscriptionIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_pubsub_subscription_iam_member";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/google-beta/r/google_pubsub_subscription_iam_member google_pubsub_subscription_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GooglePubsubSubscriptionIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: GooglePubsubSubscriptionIamMemberConfig);
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _subscription?;
    get subscription(): string;
    set subscription(value: string);
    get subscriptionInput(): string | undefined;
    private _condition;
    get condition(): GooglePubsubSubscriptionIamMemberConditionOutputReference;
    putCondition(value: GooglePubsubSubscriptionIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): GooglePubsubSubscriptionIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
