import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GoogleServiceDirectoryNamespaceIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#id GoogleServiceDirectoryNamespaceIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#member GoogleServiceDirectoryNamespaceIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#name GoogleServiceDirectoryNamespaceIamMember#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#role GoogleServiceDirectoryNamespaceIamMember#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#condition GoogleServiceDirectoryNamespaceIamMember#condition}
    */
    readonly condition?: GoogleServiceDirectoryNamespaceIamMemberCondition;
}
export interface GoogleServiceDirectoryNamespaceIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#description GoogleServiceDirectoryNamespaceIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#expression GoogleServiceDirectoryNamespaceIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member#title GoogleServiceDirectoryNamespaceIamMember#title}
    */
    readonly title: string;
}
export declare function googleServiceDirectoryNamespaceIamMemberConditionToTerraform(struct?: GoogleServiceDirectoryNamespaceIamMemberConditionOutputReference | GoogleServiceDirectoryNamespaceIamMemberCondition): any;
export declare class GoogleServiceDirectoryNamespaceIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GoogleServiceDirectoryNamespaceIamMemberCondition | undefined;
    set internalValue(value: GoogleServiceDirectoryNamespaceIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member google_service_directory_namespace_iam_member}
*/
export declare class GoogleServiceDirectoryNamespaceIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_service_directory_namespace_iam_member";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/google-beta/r/google_service_directory_namespace_iam_member google_service_directory_namespace_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GoogleServiceDirectoryNamespaceIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: GoogleServiceDirectoryNamespaceIamMemberConfig);
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): GoogleServiceDirectoryNamespaceIamMemberConditionOutputReference;
    putCondition(value: GoogleServiceDirectoryNamespaceIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): GoogleServiceDirectoryNamespaceIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
